#include <iostream>
#include <string>
#include "listas_lineares_encadeadas.h"
using namespace std;

void inicializaListaLigadaEstatica(LISTA* l) {
	l->inicio = NULO;
	l->dispo = 0;

	for(int i = 0; i < MAX - 1; i++) {
		l->A[i].prox = i + 1;
	}

	l->A[MAX - 1].prox = NULO;
}

void exibeLista(LISTA* l) {
    for (int i = l->inicio; i != NULO; i = l->A[i].prox) {
		cout << l->A[i].elem << " ";
	}

	cout << endl;
}

int obtemNo(LISTA *l) {
    int result = l->dispo;

    if(l->dispo != NULO) {
		l->dispo = l->A[l->dispo].prox;
	}

    return result;
}

void devolveNo(LISTA *l, int j) {
	l->A[j].prox = l->dispo;
	l->dispo = j;
}

bool insereNoInicio(LISTA *l, int elem) {
	int indiceNo = obtemNo(l);

	if(indiceNo == NULO) {
		return false;
	}

	l->A[indiceNo].elem = elem;
	l->A[indiceNo].prox = l->inicio;
	l->inicio = indiceNo;
	return true;
}

bool vazio(LISTA* l) {
	return l->inicio == NULO;
}

bool excluiInicio(LISTA* l) {
	if (vazio(l)){
		return false;
	}

	int aux = l->inicio;
	l->inicio = l->A[l->inicio].prox;
	devolveNo(l, aux);
	return true;
}

bool exclui(LISTA *l, int elem) {
	int ant = NULO;
	int i = l->inicio;

	while(i != NULO) {
		if(elem == l->A[i].elem){
			if(ant == NULO){
				excluiInicio(l);
			} else {
				l->A[ant].prox = l->A[i].prox;
				devolveNo(l, i);
			}

			return true;
		}
		
		ant = i;
		i = l->A[i].prox;
	}

	return false;
}

int main() {
	LISTA l;
	inicializaListaLigadaEstatica(&l);

	while(true) {
		int elem;
		char cmd;
		cin >> cmd >> elem;
		
		if(cmd == 'i') {
			cout << "insere " << elem << endl;
			insereNoInicio(&l, elem);
		} else if(cmd == 'e') {
			cout << "exclui " << elem << endl;
			exclui(&l, elem);
		} else {
			cout << "comando invalido" << endl;
		}

		cout << "exibe lista: " << ends;
		exibeLista(&l);
	}

	return 0;
}