#include <iostream>
#include <string>
#include "listas_lineares.h"
using namespace std;

bool cheia(LISTA* l) {
	if(tamanho(l) == MAX) {
		return true;
	} else {
		return false;
	}
}

void inicializaListaSequencial(LISTA* l) {
      l->nroElem = 0;
}

void exibeLista(LISTA* l) {
	for (int i = 0; i < l->nroElem; i++) {
		cout << l->A[i] << " ";
	}

	cout << endl;
}

int busca_sequencial(int elem, LISTA* l) {
	for(int i = 0; i < l->nroElem; i++) {
		if (l->A[i] == elem) {
			return i;
		}
	}	

	return 0;
}

int tamanho(LISTA* l) {
      return l->nroElem;
}

int primeiroElem(LISTA* l) {
	if(l->nroElem > 0) {
		return l->A[0]; 
	} else { 
		return LISTA_VAZIA;
	}
}

int ultimoElem(LISTA* l) {
	if(l->nroElem > 0) { 
		return l->A[l->nroElem-1]; 
	} else {
		return LISTA_VAZIA;
	}
}

int enesimoElem(LISTA* l, int n) {
	if(n > 0 && n <= l->nroElem) {
		return l->A[n-1];
	} else {
		return ERRO; // :(  a lista nao pode conter o elemento -1
	}
}

void destroiLista(LISTA* l) {
	l->nroElem = 0;
}

// devolve o numero de elementos da lista apos insercao
int insere_no_final(LISTA* l, int elem) {
	if(cheia(l)) {
		return ERRO;
	}

	l->A[l->nroElem] = elem;
	l->nroElem = l->nroElem + 1;
	return l->nroElem;
}

bool insere_na_posicao_i(int elem, int i, LISTA *l) {
	// posicao eh valida?
	if(i < 0 || i > l->nroElem) { 
		return false;
	}

	if(cheia(l)) {
		return false;
	}

	for(int j = l->nroElem; j >= (i + 1); j-- ) {
		l->A[j] = l->A[j - 1];
	}
	
	l->A[i]= elem;
	l->nroElem++;
	return true;
}

int buscaSeq(int elem, LISTA* l) {
	for(int i = 0; i < l->nroElem; i++) {
		if(elem == l->A[i]) {
			return i; // achou
		}
	}
	
	return -1;
}

// Busca sequencial em lista ordenada COM SENTINELA
int buscaSeqListaOrdenada(int elem, LISTA* l) {
	int i = 0;
	l->A[l->nroElem] = elem; // sentinela

	while(l->A[i] < elem) {
		i++;
	}

	if((i > (l->nroElem - 1)) || (l->A[i] != elem)) { 
		return -1; // não achou 
	} else { 
		return i;
	}
}

// Busca binaria em lista ordenada
int buscaBinaria(int elem, LISTA* l) {
	int i = 0;
	int f = l->nroElem - 1;
	int m;

	while(i <= f) {
		m = (i + f) / 2;

		if(l->A[m] > elem) {
			f = m - 1;
		} else if(l->A[m] < elem) {
			i = m + 1;
		} else {		
			return m;
		}
	}

	return -1;
}

int buscaBinariaRec(int elem, LISTA* l) {
	return buscaBinariaRec_(elem, l, 0, l->nroElem-1);
}

int	buscaBinariaRec_(int elem, LISTA* l, int i, int f) {
	int m = (i + f) / 2;

	if(i > f) {
	    return -1;
	}	 
  
	if(l->A[m] > elem){
		return buscaBinariaRec_(elem, l, i, m - 1);
	} 
	
	if(l->A[m] < elem){
		return buscaBinariaRec_(elem, l, m + 1, f);
	}

	return m; // l->A[m] == elem...
}

bool insereListaOrd(LISTA *l, int elem) {
	// exercicio para casa
	// NAO OLHE NA APOSTILA
}

bool exclui(LISTA *l, int elem) {
	// exercicio para casa
	// NAO OLHE NA APOSTILA
}

int main() {
	LISTA l;
	inicializaListaSequencial(&l);

	while(true) {
		int elem;
		char cmd;
		cin >> cmd >> elem;
		
		if(cmd == 'i') {
			cout << "insere " << elem << endl;
			insereListaOrd(&l, elem);
		} else if(cmd == 'e') {
			cout << "exclui " << elem << endl;
			exclui(&l, elem);
		} else {
			cout << "comando invalido" << endl;
		}

		cout << "exibe lista: " << ends;
		exibeLista(&l);
	}

	return 0;
}